﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace XamDockManagerWithWeb.DataSource
{
    public class DataGenerator
    {
        private ObservableCollection<Data> _data;

        public DataGenerator()
        {
            this._data = new ObservableCollection<Data>();

            for (int i = 1; i < 50; i++)
            {
                int _int;
                int? _nullableInt;
                double _double;
                double? _nullableDouble;
                bool _bool;
                bool? _nullableBool;
                string _string;
                DateTime _dateTime;
                DateTime? _nullableDateTime;
                Uri _uri;
                ObservableCollection<Data> _dataItems;

                _nullableBool = null;
                if (i % 3 == 0)
                {
                    _nullableBool = false;
                }
                else if (i % 3 == 1)
                {
                    _nullableBool = true;
                }

                _bool = (_nullableBool == null) ? false : (bool)_nullableBool;

                _int = i;
                _nullableInt = (_nullableBool == null) ? null : (int?)i;
                _double = i * 1.5;
                _nullableDouble = (_nullableBool == null) ? null : (double?)_double;
                _string = (_nullableBool == null) ? null : string.Format("String {0}", i);

                _dateTime = new DateTime(2009, 5, i / 24 + 1, i % 24, 0, 0);
                _nullableDateTime = (_nullableBool == null) ? null : (DateTime?)_dateTime;
                _uri = (_nullableBool == null) ? null : new Uri("http://infragistics.com");

                _dataItems = null;
                if (_nullableBool != null)
                {
                    _dataItems = new ObservableCollection<Data>();
                    _dataItems.Add(new Data(1, i, i, i, true, false, "Str", DateTime.Now, DateTime.Now, new Uri("http://infragistics.com"), null));
                    _dataItems.Add(new Data(2, null, i, null, false, null, null, DateTime.Now, null, null, null));
                    _dataItems.Add(new Data(3, i, i, i, false, true, "Str", DateTime.Now, DateTime.Now, new Uri("http://infragistics.com"), null));
                }

                this._data.Add(new Data(_int, _nullableInt, _double, _nullableDouble, _bool, _nullableBool, _string, _dateTime, _nullableDateTime, _uri, _dataItems));
            }
        }

        public ObservableCollection<Data> Data
        {
            get { return this._data; }
        }
    }
}
